
using System;
using System.Drawing;
namespace NeuroX
{
	/// <summary>
	/// 
	/// </summary>
	public abstract class NeuronSigmoid : NeuroX.Neuron
	{

		private static double NEURO_MAX = 10.0;		
		// neuron parameters (properties)
		public double sigmo;
		public double force;
		public double inertia;

		// internal variables
		protected double state;
		protected double velocity;

		//temporary variable
		protected double tmp;
		

		protected void calculateState()
		{
			velocity=force*(input-state)+inertia*velocity;
			state+=velocity;
			if (state>NEURO_MAX) state=NEURO_MAX;
			else if (state<-NEURO_MAX) state=-NEURO_MAX;
			tmp=state * sigmo;
		}
		public override void randomParam(Random r)
		{
			sigmo = 0 + r.NextDouble()*(10);
			force = 0 + r.NextDouble()*(1);		
			inertia = 0 + r.NextDouble()*(1);		
		}

		public override void reset()
		{
			state = 0;
			velocity = 0;
			tmp = 0;			
		}
		public override void standardParam()
		{	
			sigmo = 2;
			force = 0.04;
			inertia = 0.8;				
		}

		public override void reset(Random r)
		{
			state = 0 + r.NextDouble()*(1);		
			velocity = 0;
			tmp = 0;			

		}

		public override void Paint(System.Drawing.Graphics g)
		{
			base.Paint(g);
		}	
	}
}
