using System;
using System.Drawing;

namespace NeuroX
{
	/// <summary>
	/// 
	/// </summary>
	public class NeuronSigmoidNu : NeuroX.NeuronSigmoid
	{

		public NeuronSigmoidNu(Point p,double sigmo,double force,double inertia, double output,bool bOptimize)
		{
						this.bOptimize = bOptimize;
			this.sigmo = sigmo;
			this.output = output;
			this.force = force;
			this.inertia = inertia;
			point = p;
			state = 0;
			velocity = 0;
			tmp = 0;
			InitializeNeuron();		
			myPen = new Pen(Color.DarkBlue, 2);
			drawBrush = new SolidBrush(Color.DarkBlue);

		}


		public override double CalculateOutput()
		{
			calculateState();
			if (tmp<-30.0) output = 0;           //safer than exp(-tmp)
			else output = (1.0/(1.0+Math.Exp(-tmp)));     //  0..1
			return output;
		}

		public override void Paint(System.Drawing.Graphics g)
		{
			base.Paint(g);
			g.DrawString("Nu",myFont,drawBrush,new Point(point.X,point.Y-15));
		}
	
		public override object Clone()
		{
			NeuronSigmoidNu ns = new NeuronSigmoidNu(point,sigmo,force,inertia,output,bOptimize);
			ns.state = state;
			ns.tmp = tmp;
			ns.velocity = velocity;
			Clone(ns);
			return ns;	// TODO:  Add NeuronSigmoidNu.Clone implementation
		}
	}
}
