using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace NeuroX
{
	/// <summary>
	/// Summary description for WeightsEditor.
	/// </summary>
	public class WeightEditor : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox tbWeight;
		private System.Windows.Forms.Button OK;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.CheckBox cbOptimize;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		public Weight weight;
		public WeightEditor(Weight weight)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			this.weight = weight;
			tbWeight.Text = Convert.ToString(weight.dValue);
			cbOptimize.Checked = weight.bOptimize;
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tbWeight = new System.Windows.Forms.TextBox();
			this.OK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.cbOptimize = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// tbWeight
			// 
			this.tbWeight.AccessibleName = "";
			this.tbWeight.Location = new System.Drawing.Point(40, 16);
			this.tbWeight.Name = "tbWeight";
			this.tbWeight.TabIndex = 0;
			this.tbWeight.Text = "1";
			this.tbWeight.TextChanged += new System.EventHandler(this.tbWeight_TextChanged);
			// 
			// OK
			// 
			this.OK.Location = new System.Drawing.Point(152, 88);
			this.OK.Name = "OK";
			this.OK.TabIndex = 1;
			this.OK.Text = "OK";
			this.OK.Click += new System.EventHandler(this.OK_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Location = new System.Drawing.Point(40, 88);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.TabIndex = 2;
			this.btnCancel.Text = "Cancel";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// cbOptimize
			// 
			this.cbOptimize.Location = new System.Drawing.Point(40, 48);
			this.cbOptimize.Name = "cbOptimize";
			this.cbOptimize.Size = new System.Drawing.Size(152, 24);
			this.cbOptimize.TabIndex = 3;
			this.cbOptimize.Text = "optimize this weight";
			// 
			// WeightEditor
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(272, 133);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cbOptimize,
																		  this.btnCancel,
																		  this.OK,
																		  this.tbWeight});
			this.Name = "WeightEditor";
			this.Text = "WeightEditor";
			this.ResumeLayout(false);

		}
		#endregion

		private void OK_Click(object sender, System.EventArgs e)
		{
			DialogResult = DialogResult.OK;
			weight.bOptimize = cbOptimize.Checked;
			weight.dValue = Convert.ToDouble(tbWeight.Text);
			Close();
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			DialogResult = DialogResult.Cancel;
			Close();
		
		}

		private void tbWeight_TextChanged(object sender, System.EventArgs e)
		{
		
		}
	}
}
